<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');

// Récupération du premier jour de l'année, et vérification d'existence du planning
$mysqli = premiere_connexion();
$resultat = $mysqli->query('SELECT DATEDIFF(lundi,\'2000-01-01\') FROM semaines LIMIT 1');
if ( $resultat->num_rows )  {
  $r = $resultat->fetch_row();
  $premierjour = $r[0];
  $resultat->free();
}
// Si pas de planning enregistré
else  {
  $mysqli->close();
  include('installation.php');
}

// Recherche de la matière concernée
$resultat = $mysqli->query('SELECT id, cle, nom FROM matieres WHERE agenda = 1');
$mysqli->close();
if ( $resultat->num_rows )  {
  if ( !empty($_REQUEST) )  {
    while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $matiere = $r;
        break;
      }
  }
  // Matière par défaut : la première
  if ( !isset($matiere) )  {
    $resultat->data_seek(0);
    $matiere = $resultat->fetch_assoc();
  }
  $resultat->free();
}
// Si aucune matière présentant un agenda n'est enregistrée
else
  exit('<h2>Cette page ne contient aucune information.</h2>');

// Pour l'interface d'administration
if ( $admin )  {
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Traitement d'un ajout/modification/transformation
  if ( isset($_REQUEST['nmodif']) && is_numeric($n = $_REQUEST['nmodif']) )  {
    // Sauvegarde de la table contenant les données
    sauvegarde_mysql('agenda');

    // Suppression
    if ( isset($_REQUEST['suppr']) )
      $message = ( $mysqli->query("DELETE FROM agenda WHERE id = $n") ) ? 'L\'entrée a bien été supprimée.' : 'L\'entrée n\'a pas pu être supprimée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
    // Ajout/modification d'une entrée
    else  {
      if ( isset($_REQUEST['valid_modif']) )  {
        if ( !strlen($_REQUEST['texte']) )
          $message = 'Il n\'est pas possible de valider un texte vide. Pour supprimer une entrée, il faut cliquer sur Supprimer.';
        else  {
          // Vérifications des données envoyées
          $jour = preg_replace('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['jour']);
          $h_debut = preg_replace('/(\d{2})-(\d{2})/','$1-$2',$_REQUEST['h_debut']);
          $h_fin = preg_replace('/(\d{2})-(\d{2})/','$1-$2',$_REQUEST['h_fin']);
          $pour = preg_replace('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['pour']);
          $type = ( is_numeric($_POST['type']) ) ? $_POST['type'] : 1;
          $t = $mysqli->real_escape_string($_REQUEST['texte']);
          $demigroupe = ( isset($_REQUEST['demigroupe']) ) ? 1 : 0;
          // Si n > 0 : modification d'une entrée existante. Si n = 0, nouvelle entrée
          if ( $n )
            $message = ( $mysqli->query("UPDATE agenda SET jour = '$jour', h_debut = '$h_debut', h_fin = '$h_fin', pour = '$pour',
                                         type = '$type', texte = '$t', demigroupe = '$demigroupe', matiere = ${matiere['id']} WHERE id = $n")
                      && $mysqli->query("ALTER TABLE agenda ORDER BY jour,matiere,h_debut")
            ) ? 'L\'entrée a bien été modifiée.' : 'L\'entrée n\'a pas pu être modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
          else
            $message = ( $mysqli->query("INSERT INTO agenda SET jour = '$jour', h_debut = '$h_debut', h_fin = '$h_fin', pour = '$pour',
                                         type = '$type', texte = '$t', demigroupe = '$demigroupe', matiere = ${matiere['id']}")
                      && $mysqli->query("ALTER TABLE agenda ORDER BY jour,matiere,h_debut")
            ) ? 'L\'entrée a bien été ajoutée.' : 'L\'entrée n\'a pas pu être ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
        }
      }
      // Lecture
      $resultat = $mysqli->query("SELECT DATE_FORMAT(jour,'%d/%m/%Y') AS jour, TIME_FORMAT(h_debut,'%H:%i') AS hd,
                                  TIME_FORMAT(h_fin,'%H:%i') AS hf, DATE_FORMAT(pour,'%d/%m/%Y') AS pour,
                                  type, texte, IF(demigroupe=1,' checked','') AS dg FROM agenda WHERE id = $n");
      if ( $resultat->num_rows )  {
        $donnees = $resultat->fetch_assoc();
        $resultat->free();
      }
    }
  }
  
  // Conditionnement du message éventuel
  $message = ( isset($message) ) ? "<p class=\"annonce\">$message</p>\n\n  " : '';

  // Initialisation des variables pour le formulaire
  if ( !isset($donnees) || isset($_REQUEST['copie']) )  {
    $n = 0;
    $debut = '<h3>Nouvelle entrée du cahier de texte</h3>';
    $suppr = '';
  }
  else  {
    $debut = '<h3>Modification d\'une entrée</h3>';
    $suppr = '<input type="submit" name="suppr" value="Supprimer">';
  }
  // Initialisation des variables pour le formulaire
  if ( !isset($donnees) )
    $donnees = array('jour' => date('d/m/Y'), 'hd' => '08:30', 'hf' => '10:30', 'pour' => '00/00/0000', 'type' => 0, 'texte' => '&lt;p&gt;Texte&lt;/p&gt;', 'dg' => '');

  // Récupération des types
  $resultat = $mysqli->query("SELECT id,nom FROM `agenda-types`");
  $select = '';
  while ( $r = $resultat->fetch_assoc() )
    $select .= ( $r['id'] == $donnees['type'] ) ? "\n          <option value=\"${r['id']}\" selected>${r['nom']}</option>\n" : "          <option value=\"${r['id']}\">${r['nom']}</option>\n";
  $resultat->free();

  // Récupération des boutons
  $resultat = $mysqli->query("SELECT id, nom, jour, TIME_FORMAT(h_debut,'%H:%i') AS h_debut, TIME_FORMAT(h_fin,'%H:%i') AS h_fin,
                              type, demigroupe FROM `agenda-boutons` WHERE matiere = ${matiere['id']}");
  $mysqli->close();
  $raccourcis = '';
  $raccourcisjs = '';
  while ( $r = $resultat->fetch_assoc() )  {
    $raccourcis .= "\n      <p><input type=\"button\" id=\"rac${r['id']}\" value=\"${r['nom']}\"></p>";
    $r['demigroupe'] = ( $r['demigroupe'] ) ? 'true' : 'false';
    $raccourcisjs .= "
  \$('#rac${r['id']}').click(function() {
    \$('#type').val('${r['type']}');
    reglerJour(${r['jour']});
    \$('#h_debut').val('${r['h_debut']}');
    \$('#h_fin').val('${r['h_fin']}');
    \$('#demigroupe').attr('checked', ${r['demigroupe']});
  });";
  }
  $resultat->free();  

  // Formulaire d'ajout/modification
  $formulaire = <<<FIN
  $message<div class="item">
    <p>Vous pouvez ici ajouter une entrée dans votre cahier de texte. Il est aussi possible de faire apparaître en-dessous de ce formulaire des entrées déjà existantes en les sélectionnant par l'intermédiaire du menu.</p>
    <p>Les types d'entrées servent à différencier les différents types de séances (cours, td, tp...) ou ce qui peut être indiqué dans un cahier de texte (dm, interrogation, distribution de document...). Ces types peuvent être modifiés grâce à la <a href="agenda-types">page de modification</a> correspondante.</p>
    <p>Pour les types d'entrées nécessitant une heure de début et une heure de fin (comme les cours par exemple), il est important de spécifier les deux car elles seront affichées. Pour les types d'entrées ne demandant qu'une heure de début (comme par exemple les distribution de documents), l'heure de fin ne sera pas affichée et il est possible de la laisser à «&nbsp;00:00&nbsp;». Cette propriété des types d'entrées est consultable et modifiable sur la <a href="agenda-types">page de modification</a> correspondante.</p>
    <p>Pour les devoirs à rendre (par exemple les devoirs à la maison), il est possible de spécifier la date de remise «&nbsp;Pour le &nbsp;». Cela supprimera automatiquement l'affichage des heures de début et de fin. Il suffit de la laisser à «&nbsp;00/00/0000&nbsp;» pour qu'elle ne soit pas prise en compte.</p>
    <p>Des boutons de raccourci peuvent être ajoutés dans le formulaire ci-dessous. Cela permet, en un clic, de régler les données correspondant à un type de séance de la semaine, et donc de gagner du temps. Ces boutons sont modifiables sur la <a href="agenda-boutons">page de modification</a> correspondante.</p>
    <p>Les entrées sont automatiquement classées par ordre chronologique relatif à l'heure de début (y compris pour les devoirs à rendre).</p>
  </div>
  
  <!-- Formulaire de modification/copie -->
  <form action="" method="post" class="item admin">
    $debut
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider">$suppr</p>
    <div id="commandes">
      <p>Type&nbsp;:
        <select id="type" name="type">$select        </select>
      </p>
      <p>Jour&nbsp;: <input type="text" class="date" id="jour" name="jour" value="${donnees['jour']}" size="8"></p>
      <p>Heure début&nbsp;: <input type="text" class="heure" id="h_debut" name="h_debut" value="${donnees['hd']}" size="5"></p>
      <p>Heure fin&nbsp;: <input type="text" class="heure" id="h_fin" name="h_fin" value="${donnees['hf']}" size="5"></p>
      <p>Pour le&nbsp;: <input type="text" class="date" name="pour" value="${donnees['pour']}" size="8"></p>
      <p>En demi-groupe&nbsp;: <input type="checkbox" id="demigroupe" name="demigroupe" value="1"${donnees['dg']}></p>
      <hr>$raccourcis
      <p><a href="agenda-boutons?${matiere['cle']}">Ajouter/modifier un raccourci</a></p>
    </div>
    <div>
      <textarea name="texte" id="texte_agenda" rows="25" cols="100">${donnees['texte']}</textarea>
      <input type="hidden" name="nmodif" value="$n">
    </div>
  </form>

  <script type="text/javascript">

function reglerJour(n) {
  // Réglage de #jour à la date ayant n comme numéro de la semaine (1->lundi...)
  var today=new Date();
  var t=today.getDay();
  t = n-t;
  if ( t>0 ) { t-=7; }
  $('#jour').datepick('setDate',t+'d');
}

$( function() {
  $('.date').datepick({dateFormat: 'dd/mm/yyyy'});
  $('.heure').timeEntry({timeSteps: [1, 30, 0]});$raccourcisjs
});

  </script>

  <script type="text/javascript" src="js/textarea.js"></script>

  <div class="item">
    <p>Les entrées du cahier de texte affichées ci-dessous sont modifiables. Il est possible de faire apparaître d'autres entrées déjà existantes grâce au menu.</p>
    <p>Le bouton «&nbsp;Recopier&nbsp;» récupère les données de l'entrée concernée et permet d'en créer une nouvelle. Les modifications effectuées dans le formulaire affectent donc la nouvelle entrée, l'originale reste inchangée.</p>
  </div>


FIN;
}

// Supplément au menu : toutes les semaines de cours existantes
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
$resultat = $mysqli->query("SELECT DATE_FORMAT(lundi,'%e/%m'), (DATEDIFF(lundi,'2000-01-01')-$premierjour+1),pascolle FROM semaines WHERE lundi < NOW()");
if ( $resultat->num_rows )  {
  $menusupp = "    <h4>Semaines</h4>\n    <p class=\"menusupp\">\n";
  $s = $r = $resultat->fetch_row();
  while ( $r = $resultat->fetch_row() )  {
    // On n'affiche que les semaines de cours, pas celle de vacances
    if ( $s[2] < 2 )  {
      $menusupp .= "      <a class=\"ligne\" href=\"agenda?${matiere['cle']}&amp;debut=${s[1]}&amp;fin=${r[1]}$urladmin\">${s[0]}</a>&nbsp;-\n";
      // Premier jour par défaut
      $j1 = $s[1];
    }
    $s = $r;
  }
  $resultat->free();
  // Dernière semaine, sans borne finale
  if ( $s[2] < 2 )  {
    $menusupp .= "      <a class=\"ligne\" href=\"agenda?${matiere['cle']}&amp;debut=${s[1]}$urladmin\">${s[0]}</a>\n    </p>\n";
    $j1 = $s[1];
  }
  else
    $menusupp = substr($menusupp,0,strlen($menusupp)-8)."    </p>\n";
}
// Pas de résultat : le cahier de texte est vide, ou l'année pas encore commencée
else  {
  $menusupp = '';
  $j1 = 1;
}

// Supplément au menu : tous les types d'entrées existants (pour la matière)
$resultat = $mysqli->query("SELECT at.cle, at.nom FROM agenda AS a JOIN `agenda-types` AS at ON a.type = at.id WHERE a.matiere = ${matiere['id']} GROUP BY a.type");
if ( $resultat->num_rows )  {
  $menusupp .= "    <h4>Types d'entrées</h4>\n    <p class=\"menusupp\">\n";
  while ( $r = $resultat->fetch_assoc() )  {
    $menusupp .= "      <a class=\"ligne\" href=\"agenda?${matiere['cle']}&amp;type=${r['cle']}$urladmin\">${r['nom']}</a>&nbsp;-\n";
    $types[$r['cle']] = $r['nom'];
  }
  $resultat->free();
  $menusupp = substr($menusupp,0,strlen($menusupp)-8)."    </p>\n";
}

// Gestion des demandes : dates de début et de fin, type d'entrée
// Le sous-titre affiché et la requête sont réglés ici
if ( isset($_REQUEST['debut']) && is_numeric($_REQUEST['debut']) )
  $j1 = max(1,$_REQUEST['debut']);
$semaine = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
$jour = mktime(0,0,0,1,1,2000)+86400*($premierjour+$j1-1);
$titre = 'Depuis le '.$semaine[date('w',$jour)].' '.date('j/m',$jour);
$requete = "(DATEDIFF(a.jour,'2000-01-01')-$premierjour+1) >= $j1";
// Borne finale
if ( isset($_REQUEST['fin']) && is_numeric($j2 = $_REQUEST['fin']) && ( $j1 < $j2 ) )  {
  $jour = mktime(0,0,0,1,1,2000)+86400*($premierjour+$j2-1);
  $titre = 'Entre'.substr($titre,6).' et le '.$semaine[date('w',$jour)].' '.date('j/m',$jour);
  $requete .= " AND (DATEDIFF(a.jour,'2000-01-01')-$premierjour+1) < $j2";
}
// Type d'entrée
if ( isset($_REQUEST['type']) && isset($types[$_REQUEST['type']]) )  {
  $titre = $types[$_REQUEST['type']].' '.strtolower($titre);
  if ( isset($_REQUEST['debut']) || isset($_REQUEST['fin']) )
    $requete .= " AND at.cle = '${_REQUEST['type']}'";
  else
    $requete = "at.cle = '${_REQUEST['type']}'";
}

//////////
// HTML //
//////////
// Haut de page et menu
$t = "Cahier de texte - ${matiere['nom']}";
$p = "agenda?${matiere['cle']}";
include('haut.php');

// Formulaire éventuel de modification/ajout
if ( isset($formulaire) )
  echo $formulaire;

// Sous-titre
echo "  <h2>$titre</h2>\n\n";

// Récupération des entrées
$resultat = $mysqli->query("SELECT a.id AS id, at.titre AS tt, DATE_FORMAT(a.jour,'%w') AS j,
                            DATE_FORMAT(a.jour,'%d/%m/%Y') AS d, DATE_FORMAT(a.pour,'%d/%m/%Y') AS p,
                            TIME_FORMAT(a.h_debut,'%kh%i') AS hd, TIME_FORMAT(a.h_fin,'%kh%i') AS hf,
                            at.h_fin AS hft, a.texte AS t, IF(a.demigroupe=1,' (en demi-groupe)','') AS dg
                            FROM agenda AS a LEFT JOIN `agenda-types` AS at ON at.id = a.type
                            WHERE $requete AND a.matiere = ${matiere['id']}");
$mysqli->close();
if ( $resultat->num_rows )  {
  $j = -1;
  while ( $r = $resultat->fetch_assoc() )  {
    // Affichage d'une nouvelle div si nouvelle journée
    if ( $j != $r['j'] )  {
      if ( $j != -1 )
        echo "  </div>\n\n";
      echo "  <div class=\"cdtjour\">\n\n";
      $j = $r['j'];
    }
    if ( substr($r['p'],0,2) == '00' )  {
      $pour = '';
      $heure = ( $r['hft'] ) ? " de ${r['hd']} à ${r['hf']}" : " à ${r['hd']}";
    }
    else  {
      $pour = " pour le ${r['p']}";
      $heure = '';
    }
    // Affichage des entrées
    $aff = ( $admin ) ? <<<FIN

    <form class="bouton_ok" action="" method="post"><div>
      <input type="submit" name="copie" value="Recopier" title="Prendre les données de l'entrée et les positionner dans le formulaire comme s'il s'agissait d'un nouvel entrée">
      <input type="submit" name="modif" value="Modifier/Supprimer" title="Afficher l'entrée et demander une modification ou une suppression">
      <input type="hidden" name="nmodif" value="${r['id']}">
    </div></form>
FIN
: '';
    echo <<<FIN
  <div class="item cdt">$aff
    <p class="titre">${semaine[$r['j']]} ${r['d']}$heure&nbsp;: ${r['tt']}${r['dg']}$pour</p>
    <div>
${r['t']}
    </div>
  </div>


FIN;
  }
  $resultat->free();
  echo "  </div>\n\n";
}
else
  echo '  <h4 class="warning">Le cahier de texte ne contient pas d\'entrée demandée.</h4>

';

// Bas de page
include('bas.php');
?>

