<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');

// Recherche de la matière concernée
$mysqli = premiere_connexion();
$resultat = $mysqli->query('SELECT id, cle, nom FROM matieres');
if ( $resultat->num_rows )  {
  if ( !empty($_REQUEST) )  {
    while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $matiere = $r;
        break;
      }
    $resultat->free();
  }
  // Matière par défaut : aucune
  if ( !isset($matiere) )
    $matiere = array('id'=>0, 'cle'=>'', 'nom'=>'Toutes matières');
}
// Si pas de matière enregistrée
else  {
  $mysqli->close();
  include('installation.php');
}

// Supplément au menu : tous les répertoires non vides
$resultat = $mysqli->query("SELECT r.id, r.nom, r.titre FROM repertoires AS r
                            JOIN documents AS d ON d.repertoire = r.id
                            WHERE matiere = ${matiere['id']} GROUP BY r.id");
if ( $resultat->num_rows )  {
  $menusupp = "    <h4>Répertoires</h4>\n    <p class=\"menusupp\">\n";
  while ( $r = $resultat->fetch_assoc() )  {
    $menusupp .= "      <a href=\"docs?${matiere['cle']}&amp;rep=".htmlentities($r['nom'],ENT_NOQUOTES,'UTF-8')."\">${r['titre']}</a>\n";
    $repertoires[$r['nom']] = $r;
  }
  $resultat->free();
  $menusupp .= "    </p>\n";
}
else
  $menusupp = '';

//////////
// HTML //
//////////
// Haut de page et menu
$p = rtrim("docs?${matiere['cle']}",'?');
$t = "Documents à télécharger - ${matiere['nom']}";
include('haut.php');

// Si on a demandé un répertoire particulier, on supprime les autres
if ( isset($_REQUEST['rep']) && isset($repertoires[$_REQUEST['rep']]) )
  $repertoires = array($repertoires[$_REQUEST['rep']]);

// Si on a demandé un ordre particulier
if ( isset($_REQUEST['ordre']) )  {
  switch ( $_REQUEST['ordre'] )  {
    case 'Date (récents en haut)' :
      $ordre = ' ORDER BY dateupload DESC'; break; 
    case 'Date (anciens en haut)' :
      $ordre = ' ORDER BY dateupload ASC'; break; 
    case 'Nom' :
      $ordre = ' ORDER BY t';
  }
}
else
  $ordre = '';

if ( isset($repertoires) )  {
  echo <<<FIN
  <form class="item" action="" method="post">
    <p>Classer par&nbsp;: &nbsp;&nbsp;&nbsp;
      <input type="submit" name="ordre" value="Date (récents en haut)"> &nbsp;&nbsp;&nbsp;
      <input type="submit" name="ordre" value="Date (anciens en haut)"> &nbsp;&nbsp;&nbsp;
      <input type="submit" name="ordre" value="Nom"> &nbsp;&nbsp;&nbsp;
    </p>
  </form>


FIN;
  foreach ( $repertoires as $r )  {
    // Récupération et affichage des documents du répertoire
    $resultat = $mysqli->query("SELECT nom, IF(CHAR_LENGTH(titre)>0,titre,nom) AS t, DATE_FORMAT(dateupload,'%d/%m/%Y') as du, taille
                                FROM documents WHERE repertoire = ${r['id']} AND lien = 1$ordre");
    if ( $n = $resultat->num_rows )  {
      $r['titre'] .= ( $n > 1 ) ? " ($n documents)" : " ($n document)";
      echo "  <h3>${r['titre']}</h3>\n";
      $chemin = ( $matiere['id'] ) ? "documents/${matiere['cle']}/" : 'documents/';
      while ( $d = $resultat->fetch_assoc() )
        echo "    <p>[&nbsp;Ajouté le ${d['du']}&nbsp;]&nbsp;<a href=\"$chemin".htmlentities($r['nom'].'/'.$d['nom'],ENT_NOQUOTES,'UTF-8')."\">${d['t']}</a>&nbsp;(${d['taille']})</p>\n";
      $resultat->free();
    }
    echo "\n";
  }
}
else
  echo "  <h3>${r['titre']}</h3>\n  <h4 class=\"warning\">Il n'y a aucun document disponible ici.</h4>\n\n";
$mysqli->close();

// Bas de page
include('bas.php');
?>

