<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

// La connexion MySQL (lien $mysqli) doit être obligatoirement établie par le script appelant.
// $t et $p doivent être réglés par le script appelant
// $t = titre de la page, $p = cle de la page
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <title><?php echo $t; ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <link rel="stylesheet" href="css/style.css" type="text/css" media="screen">
  <link rel="stylesheet" href="css/print.css" type="text/css" media="print">
  <link rel="stylesheet" href="css/couleurs.css" type="text/css" media="screen">
  <link rel="stylesheet" href="css/mobile.css" type="text/css" media="handheld, only screen and (max-device-width:480px)">
<?php
if ( $admin )
echo <<< FIN
  <link rel="stylesheet" href="js/jquery.datepick.css" type="text/css">
  <link rel="stylesheet" href="js/jquery.timeentry.css" type="text/css">
  <script type="text/javascript" src="js/jquery.js"></script>
  <script type="text/javascript" src="js/jquery.datepick.js"></script>
  <script type="text/javascript" src="js/jquery.datepick-fr.js"></script>
  <script type="text/javascript" src="js/jquery.timeentry.js"></script>
  <script type="text/javascript" src="js/jquery.timeentry-fr.js"></script>

FIN;
?>
</head>
<body>

<h1><?php echo $t; ?></h1>

<div id="menu">
  <div>
<?php
// Fabrication du menu : pages d'informations, page de téléchargement des
// documents, pages des programmes de colles/cahiers de texte/téléchargement
// pour chaque matière. L'interface d'administration rajoute ses propres pages.
// $p doit être déjà définie comme étant la clé correspondant à la page.

// Récupération et affichage des pages
$resultat = $mysqli->query('SELECT cle, nom FROM pages');
if ( $resultat->num_rows )  {
  if ( $admin )
    echo <<<FIN
    <form id="deconnexion" action="" method="post"><div><input type="submit" name="deconnexion" value="Se déconnecter"></div></form>
    <h3>Modifier des pages d'informations</h3>

FIN;
  while ( $r = $resultat->fetch_assoc() )
    if ( $p == $r['cle'] )
      echo "    <a id=\"actuel\" href=\".?${r['cle']}$urladmin\">${r['nom']}</a>\n";
    else
      echo "    <a href=\".?${r['cle']}$urladmin\">${r['nom']}</a>\n";
  $resultat->free();
}

if ( !$admin )  {
  // Page de téléchargement
  if ( $p == 'docs' )
    echo "    <a id=\"actuel\" href=\"docs\">Documents à télécharger</a>\n$menusupp";
  else
    echo "    <a href=\"docs\">Documents à télécharger</a>\n";

  echo "  </div>\n";

  // Récupération et affichage des matières
  $resultat = $mysqli->query('SELECT cle, nom, colles, agenda, docs FROM matieres');
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      echo "  <div>\n    <h3>${r['nom']}</h3>\n";
      if ( $r['colles'] )  {
        if ( $p == "colles?${r['cle']}" )
          echo "    <a id=\"actuel\" href=\"colles?${r['cle']}\">Programme de colles</a>\n$menusupp";
        else
          echo "    <a href=\"colles?${r['cle']}\">Programme de colles</a>\n";
      }
      if ( $r['agenda'] )  {
        if ( $p == "agenda?${r['cle']}" )
          echo "    <a id=\"actuel\" href=\"agenda?${r['cle']}\">Cahier de texte</a>\n$menusupp";
        else
          echo "    <a href=\"agenda?${r['cle']}\">Cahier de texte</a>\n";
      }
      if ( $r['docs'] )  {
        if ( $p == "docs?${r['cle']}" )
          echo "    <a id=\"actuel\" href=\"docs?${r['cle']}\">Documents à télécharger</a>\n$menusupp";
        else
          echo "    <a href=\"docs?${r['cle']}\">Documents à télécharger</a>\n";
      }
      echo "  </div>\n";
    }
    $resultat->free();
  }
  
  // Lien vers l'interface d'administration
  $proto = ( $https ) ? 'https://' : 'http://';
  if ( strlen($siteadmin) )
    echo "  <div>\n    <a href=\"$proto$siteadmin\">Administration du site</a>";
  else
    echo "  <div>\n    <a href=\"$proto$site/?admin\">Administration du site</a>";
}

// Affichages supplémentaires différents sur l'interface d'administration ou non
else  {
  if ( !isset($menusupp) )
    $menusupp = '';
  echo "  </div>\n  <div>\n    <h3>Modifier mes données</h3>\n";
  $liens = array(
    "colles?${_SESSION['mat']}" => "Mon programme de colles",
    "agenda?${_SESSION['mat']}" => "Mon cahier de texte",
    "agenda-boutons?${_SESSION['mat']}" => "Mes raccourcis du cahier de texte",
    "repertoires?${_SESSION['mat']}" => "Mes répertoires",
    "upload?${_SESSION['mat']}" => "Mes documents");
  // Liens auquels on ajoute éventuellement "&admin" si besoin
  // (en fait inutile pour repertoires.php et upload.php)
  foreach ( $liens as $k => $v )
    if ( $p == $k )
      echo "    <a id=\"actuel\" href=\"$k$urladmin\">$v</a>\n$menusupp";
    else
      echo "    <a href=\"$k$urladmin\">$v</a>\n";
  echo "  </div>\n  <div>\n    <h3>Modifier les données globales du site</h3>\n";
  $liens = array(
    "utilisateurs" => "Les utilisateurs",
    "matieres" => "Les matières",
    "pages" => "Les pages du site",
    "repertoires" => "Les répertoires (toutes matières)",
    "upload" => "Les documents (toutes matières)",
    "semaines" => "Les semaines du planning annuel",
    "agenda-types" => "Les types de séances pour les cahiers de texte");
  foreach ( $liens as $k => $v )
    if ( $p == $k )
      echo "    <a id=\"actuel\" href=\"$k\">$v</a>\n";
    else
      echo "    <a href=\"$k\">$v</a>\n";
  echo "  </div>\n  <div>\n    <a href=\"http://$site/\">Voir le site public (pensez à revenir vous déconnecter...)</a>";
}
?>

  </div>
</div>

<div id="contenu">

