<?php
// Sécurité et récupération des données de configuration
// La connexion doit obligatoirement être sécurisée (OK=2).
define('OK',2);
include('debut.php');

// Traitement d'un ajout/modification/transformation
if ( isset($_REQUEST['nmodif']) && is_numeric($n = $_REQUEST['nmodif']) )  {
  // Sauvegarde de la table contenant les données
  sauvegarde_mysql('matieres');
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Pour déplacement et suppression : vérification de l'existence et récupération de l'ordre
  if ( isset($_REQUEST['monte']) || isset($_REQUEST['suppr']) )  {
    $resultat = $mysqli->query("SELECT ordre,nom FROM matieres WHERE id = $n");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_row();
      $ordre = $r[0];
      $nom = $r[1];
      $resultat->free();

      // Déplacement
      if ( isset($_REQUEST['monte']) )
        $message = ( $mysqli->query("UPDATE matieres SET ordre = (2*$ordre-1-ordre) WHERE ordre = $ordre OR ordre = ($ordre-1)")
                  && $mysqli->query('ALTER TABLE matieres ORDER BY ordre')
        ) ? "La matière «&nbsp;$nom&nbsp;» a bien été montée d'une place." : "La matière «&nbsp;$nom&nbsp;» n'a pas pu être déplacée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      // Suppression
      elseif ( isset($_REQUEST['suppr']) )
        $message = ( $mysqli->query("DELETE FROM matieres WHERE id = $n")
                  && $mysqli->query("UPDATE matieres SET ordre = (ordre-1) WHERE ordre > $ordre")
        ) ? "La matière «&nbsp;$nom&nbsp;» a bien été supprimée." : "La matière «&nbsp;$nom&nbsp;» n'a pas pu être supprimée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }
  }
  // Ajout/modification d'une matière
  elseif ( isset($_REQUEST['valid_modif']) )  {
    if ( !strlen($_REQUEST['cle']) || !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider une matière sans clé ou sans nom. Pour supprimer une matière, il faut cliquer sur Supprimer.';
    else  {
      // Vérifications des données envoyées
      $cle = $mysqli->real_escape_string($_REQUEST['cle']);
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      $colles = ( isset($_REQUEST['colles']) ) ? 1 : 0;
      $agenda = ( isset($_REQUEST['agenda']) ) ? 1 : 0;
      // Si n > 0 : modification d'une matière existante. Si n = 0, nouvelle matière
      if ( $n )
        $message = ( $mysqli->query("UPDATE matieres SET cle = '$cle', nom = '$nom', colles = $colles, agenda = $agenda  WHERE id = $n")
        ) ? "La matière «&nbsp;$nom&nbsp;» a bien été modifiée." : "La matière «&nbsp;$nom&nbsp;» n'a pas pu être modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      else
        $message = ( $mysqli->query("INSERT INTO matieres SET cle = '$cle', nom = '$nom', colles = $colles, agenda = $agenda, docs = 0, ordre = ((SELECT MAX(m.ordre) FROM matieres AS m)+1)")
                  && $mysqli->query('ALTER TABLE matieres ORDER BY ordre')
        ) ? "La matière «&nbsp;$nom&nbsp;» a bien été ajoutée." : "La matière «&nbsp;$nom&nbsp;» n'a pas pu être ajoutée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }
  }
  $mysqli->close();
}

//////////
// HTML //
//////////
// Haut de page et menu
$p = 'matieres';
$t = 'Modifications des matieres';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

// Affichage du message éventuel
if ( isset($message) )
  echo "  <p class=\"annonce\">$message</p>\n\n";

// Description et formulaire vide pour ajout
?>
  <div class="item">
    <p>Les différentes matières peuvent être définies ici. Pour chaque matière, il est possible de déterminer si on affichera un programme de colles et/ou un cahier de texte. Il est possible de refuser les deux et de n'afficher ainsi que la possibilité de télécharger des documents envoyés.</p>
  </div>

  <form action="" method="post" class="item admin">
    <h3>Ajout d'une nouvelle matière</h3>
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider"></p>
    <h4>Nom complet&nbsp;: <input type="text" name="nom" value="" size="30"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Clé&nbsp;: <input type="text" name="cle" value="" size="20">
    </h4>
    <h4>Afficher le programme de colles&nbsp;: <input type="checkbox" name="colles" value="1" checked> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Afficher le cahier de texte&nbsp;: <input type="checkbox" name="agenda" value="1" checked>
     <input type="hidden" name="nmodif" value="0">
    </h4>
  </form>

  <div class="item">
    <p>Le nom complet est le nom de la matière qui sera affiché dans le menu et dans les titres des pages associées à la matière. Mettre un nom plutôt long et éventuellement en plusieurs mots est possible. Par exemple «&nbsp;Mathématiques&nbsp;», «&nbsp;Sciences Physiques&nbsp;».</p>
    <p>La clé est un mot-clé qui sera utilisé uniquement dans les adresses web vers les pages associées à la matière&nbsp;: «&nbsp;<code>http://<?php echo $site; ?>/agenda?[matière]</code>&nbsp;» affiche le cahier de texte,  «&nbsp;<code>http://<?php echo $site; ?>/colles?[matière]</code>&nbsp;» affiche le programme de colles, «&nbsp;<code>http://<?php echo $site; ?>/docs?[matière]</code>&nbsp;» affiche la page de téléchargement de documents. Il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple «&nbsp;maths&nbsp;», «&nbsp;physique&nbsp;».</p>
    <p>Les deux cases à cocher définissent si oui ou non sont affichés le programme de colles et le cahier de texte.</p>
    <p>Toutes ces données sont modifiables ultérieurement sans que cela pose un problème particulier.</p>
  </div>
  
<?php
// Récupération et affichage des matières
$resultat = $mysqli->query('SELECT id, ordre, cle, nom, IF(colles=1,\' checked\',\'\') AS colles, IF(agenda=1,\' checked\',\'\') AS agenda FROM matieres');
$mysqli->close();
if ( $n = $resultat->num_rows )  {
?>
  <h2>Matières existantes</h2>

  <div class="item">
    <p>Il est possible de modifier les matières existantes. Cela ne changera rien au fonctionnement interne du site, mais modifiera l'affichage. Modifier le nom complet changera l'affichage du menu et des titres des pages associées à la matière. Modifier la clé changera les adresses web correspondantes et pourrait éventuellement affecter des liens qui auraient été écrits à la main (cela est très peu probable). Les liens générés automatiquement comme ceux du menu seront immédiatement modifiés.</p>
    <p>Décocher une des deux cases supprime l'affichage du programme de colles ou du cahier de texte. Cela ne supprime pas en réalité ce qui a été entré dans la base de données&nbsp;: en cochant à nouveau la case ultérieurement, on pourra faire réapparaître le programme de colles/cahier de texte et son contenu.</p>
    <p>Attention&nbsp;: supprimer une matière est définitif. Ce qui a été entré dans la base de données (programmes de colles, cahier de texte, réglages...) ainsi que les documents envoyés ne seront pas supprimés pour autant, mais ne seront plus visibles de façon simple. Créer à nouveau une nouvelle matière avec le même nom complet et la même clé ne sera pas suffisant (il faudra que l'administrateur du site change l'identifiant interne).</p>
    <p>Il est aussi possible de modifier l'ordre des matières&nbsp;: cela modifie leur ordre d'apparition dans le menu.</p>
  </div>
  
<?php
  // Suppression possible uniquement si plus d'une matière
  $suppr = ( $n > 1 ) ? '<input type="submit" name="suppr" value="Supprimer">' : '';
  // Affichage
  while ( $r = $resultat->fetch_assoc() )  {
    $monte = ( $r['ordre'] > 1 ) ? '<input type="submit" name="monte" value="&uarr;" title="Remonter la matière dans l\'ordre d\'apparition dans le menu">' : '';
    echo <<<FIN
  <form action="" method="post" class="item admin">
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider">$suppr$monte</p>
    <h4>Nom complet&nbsp;: <input type="text" name="nom" value="${r['nom']}" size="30"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Clé&nbsp;: <input type="text" name="cle" value="${r['cle']}" size="20">
    </h4>
    <h4>Afficher le programme de colle&nbsp;: <input type="checkbox" name="colles" value="1"${r['colles']}> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Afficher le cahier de texte&nbsp;: <input type="checkbox" name="agenda" value="1"${r['agenda']}>
      <input type="hidden" name="nmodif" value="${r['id']}">
    </h4>
  </form>


FIN;
  }
  $resultat->free();
}
else
  echo "  <h4 class=\"warning\">Aucune matière n'est encore définie&nbsp;: il s'agit d'une des première choses à faire pour que le site fonctionne correctement.</h4>\n\n";

// Bas de page
include('bas.php');
?>

