<?php
// Sécurité et récupération des données de configuration
// La connexion doit obligatoirement être sécurisée (OK=2).
define('OK',2);
include('debut.php');

// Traitement des modifications
if ( isset($_REQUEST['valid_modif']) && !empty($_REQUEST['lundi']) )  {
  // Sauvegarde de la table contenant les données
  sauvegarde_mysql('semaines');

  // Récupération et validation de l'ensemble des paramètres
  $lundis = $_REQUEST['lundi'];
  $colles = $_REQUEST['colle'];
  $pc1 = $_REQUEST['pc'];
  $pc2 = $_REQUEST['pascolle'];
  $n = count($lundis);
  $valeurs = '';
  $pascolles = array(2,3,4,5,6);
  for ( $i = 0; $i <$n; $i++ )  {
    if ( strlen($lundis[$i]) )  {
      $lundi = preg_replace('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$lundis[$i]);
      if ( strlen($lundi) == 10 )  {
        $colle = is_numeric($colles[$i]) ? $colles[$i] : 0;
        if ( !in_array($pascolle = $pc2[$i],$pascolles) )
          $pascolle = ( isset($pc1[$i]) ) ? 1 : 0;
        $valeurs .= " ('$lundi',$colle,$pascolle),";
      }
    }
  }

  // Remplacement de l'ensemble dans la base
  if ( strlen($valeurs) )  {
    $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
    $mysqli->set_charset('utf8');
    $message = ( $mysqli->query('DELETE FROM semaines')
              && $mysqli->query('INSERT INTO semaines (lundi, colle, pascolle) VALUES'.substr($valeurs, 0, -1))
              && $mysqli->query('ALTER TABLE semaines ORDER BY lundi')
    ) ? 'Les semaines ont bien été toutes remises à jour.' : 'Les semaines n\'ont pas pu être modifiées. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
    $mysqli->close();
  }
}

// Select sur les vacances
$select_vacances = <<<FIN
              <option value="0">Période scolaire</option>
              <option value="2">Vacances de Toussaint</option>
              <option value="3">Vacances de Noël</option>
              <option value="4">Vacances d'hiver</option>
              <option value="5">Vacances de printemps</option>
              <option value="6">Vacances d'été (fin des cours)</option>

FIN;

// Fonction d'affichage du formulaire
function affiche_formulaire($n,$r)  {
  $select = str_replace("\"${r['pascolle']}\"","\"${r['pascolle']}\" selected",$GLOBALS['select_vacances']);
  if ( $r['pc'] || $r['pascolle'] )
    $r['colle'] = '';
  if ( strlen($r['jour']) )  {
    $semaine = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
    $r['jour'] = $semaine[$r['jour']];
  }
  echo <<<FIN
          <tr id="ligne$n">
            <td>${r['jour']}&nbsp;&nbsp;<input type="text" class="date" name="lundi[$n]" value="${r['lundi']}" size="8"></td>
            <td><input type="text" name="colle[$n]" value="${r['colle']}" size="2"></td>
            <td><input type="checkbox" name="pc[$n]" value="1"${r['pc']}></td>
            <td><select name="pascolle[$n]">
$select            </select></td>
          </tr>

FIN;
}

//////////
// HTML //
//////////
// Haut de page et menu
$p = 'semaines';
$t = 'Modifications des semaines du planning annuel';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

// Affichage du message éventuel
if ( isset($message) )
  echo "  <p class=\"annonce\">$message</p>\n\n";

// Aide et début du formulaire
?>
  
  <div class='item'>
    <p>Vous pouvez ici modifier le planning annuel, l'ensemble des semaines et des vacances ainsi que la numérotation des semaines de colles. Attention aux modifications&nbsp;: elles sont appliquées simultanément à toutes les matières et peuvent avoir des conséquences. Ce planning annuel est utilisé pour les programmes de colles et pour les cahiers de texte.</p>
    <p>Chaque ligne du tableau correspond à une semaine, où l'on inscrit le premier jour (cela peut être un jeudi pour un retour de vacances).</p>
    <p>Pour les semaines sans colle, il faut cocher la case «&nbsp;Pas de colle&nbsp;» et ne pas inscrire de numéro.</p>
    <p>La validation des données se fait de façon globale, par les boutons de validation en haut ou en bas du formulaire&nbsp;: toutes les modifications sont prises en compte en une seule fois. De plus, les semaines sont automatiquement réorganisées par ordre chronologique&nbsp;: pas besoin de tout effacer et tout réécrire pour insérer une semaine oubliée, il suffit de l'ajouter en bas.</p>
    <p>Pour chaque vacances, il faut spécifier avec une seule ligne le début (le premier lundi) et utiliser la dernière colonne.</p>
    <p>Pour supprimer une semaine, il suffit de vider la date et de valider le tableau.</p>
  </div>

  <div class='item'>
    <form action="" method="post">
      <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider"></p>
      <table id="semaines" class="admin">
        <thead>
          <tr>
            <th>Début de semaine</th>
            <th>N° de colle</th>
            <th>Pas de colle</th>
            <th>Vacances</th>
          </tr>
        </thead>
        <tbody>
<?php
// Récupération et affichage des matières
$resultat = $mysqli->query('SELECT DATE_FORMAT(lundi,\'%w\') AS jour, DATE_FORMAT(lundi,\'%d/%m/%Y\') AS lundi, colle, IF(pascolle=1,\' checked\',\'\') AS pc, IF(pascolle=1,0,pascolle) AS pascolle FROM semaines');
$mysqli->close();
$n = 0;
if ( $resultat->num_rows )  {
  while ( $r = $resultat->fetch_assoc() )
    affiche_formulaire($n++,$r);
  $resultat->free();
}

// Affichage d'un formulaire vide pour ajout
affiche_formulaire($n++,array('jour'=>'','lundi'=>'','colle'=>'','pc'=>'','pascolle'=>'0'));

// Fin du formulaire
?>
        </tbody>
      </table>

      <p class="bouton_ok_bas">
        <input type="button" id="ajouter" value="Ajouter une ligne au tableau"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <input type="button" id="retirer" value="Retirer la dernière ligne du tableau"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <input type="submit" name="valid_modif" value="Valider">
      </p>
    </form>
  </div>

  <script type="text/javascript">
$( function() {
  var n = <?php echo $n; ?>;
  $('.date').datepick({dateFormat: 'dd/mm/yyyy'});
  $('#ajouter').click(function () {
    $('#ligne'+(n-1)).clone(true).attr('id','ligne'+n).insertAfter($('#ligne'+(n-1)));
    $('#ligne'+n).find('input[name="lundi['+(n-1)+']"]').attr('name','lundi['+n+']');
    $('#ligne'+n).find('input[name="colle['+(n-1)+']"]').attr('name','colle['+n+']');
    $('#ligne'+n).find('input[name="pc['+(n-1)+']"]').attr('name','pc['+n+']');
    $('#ligne'+n).find('select[name="pascolle['+(n-1)+']"]').attr('name','pascolle['+n+']');
    n++;
  });
  $('#retirer').click(function () {
    $('#ligne'+(n-1)).remove();
    n--;
  });
});
  </script>

<?php
// Bas de page
include('bas.php');
?>

