<?php
// Sécurité et récupération des données de configuration
// La connexion doit obligatoirement être sécurisée (OK=2).
define('OK',2);
include('debut.php');

// Recherche de la matière concernée
$mysqli = premiere_connexion();
if ( !empty($_REQUEST) )  {
  $resultat = $mysqli->query('SELECT id, cle, nom FROM matieres');
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $matiere = $r;
        break;
      }
    $resultat->free();
  }
}
// Matière par défaut : aucune
if ( !isset($matiere) )
  $matiere = array('id'=>0, 'cle'=>'', 'nom'=>'Toutes matières');
  
// Récupération de tous les répertoires existants, des matières et du nombre de documents
$resultat = $mysqli->query("SELECT r.id, IF(m.id,CONCAT(m.cle,'/',r.nom),r.nom) AS chemin, r.matiere, r.titre
                            FROM repertoires AS r LEFT JOIN matieres AS m ON r.matiere = m.id");
$mysqli->close();
if ( $resultat->num_rows )  {
  $select_reps_tout = $select_reps_mat = '';
  while ( $r = $resultat->fetch_assoc() ) {
    // Tous les répertoires : utile pour la partie modification
    $select_reps_tout .= "          <option value=\"${r['id']}\">${r['chemin']}</option>\n";
    $repertoires[$r['id']] = "documents/${r['chemin']}";
    if ( $r['matiere'] == $matiere['id'] )  {
      $select_reps_mat .= "        <option value=\"${r['id']}\">${r['chemin']}</option>\n";
      $reps_mat[$r['id']] = $r['titre'];
    }
  }
  $resultat->free();
}

// Traitement d'un ajout/modification/transformation
if ( isset($_REQUEST['nmodif']) && is_numeric($n = $_REQUEST['nmodif']) )  {
  // Sauvegarde de la table contenant les données
  sauvegarde_mysql('documents');
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');
  
  // Récupération du document avant modification (sauf si création)
  if ( $n )  {
    $resultat = $mysqli->query("SELECT nom, repertoire FROM documents WHERE id = $n");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_row();
      $nom = $r[0];
      $chemin = "${repertoires[$r[1]]}/$nom";
      $resultat->free();
    }
  }
  setlocale(LC_CTYPE, "fr_FR.UTF-8");

  // Suppression
  if ( isset($_REQUEST['suppr']) && isset($chemin) )  {
    // Création d'un répertoire temporaire
    $tmp = '/tmp/'.uniqid();
    while ( is_dir($tmp) )
      $tmp = '/tmp/'.uniqid();
    if ( !mkdir($tmp) )
      $message = "Le document «&nbsp;$nom&nbsp;» n'a pas pu être supprimé, car le répertoire temporaire (/tmp) n'est pas accessible.";
    else  {
      // Déplacement du répertoire dans le répertoire temporaire
      exec('mv '.escapeshellarg($chemin)." $tmp/",$out,$nok);
      if ( $nok )
        $message = "Le document «&nbsp;$nom&nbsp;» n'a pas pu être supprimé, car il n'a pas pu être déplacé dans le répertoire temporaire. Résultat de la commande <code>mv</code> : $nok.";
      // Écriture MySQL
      elseif ( $mysqli->query("DELETE FROM documents WHERE id = $n") )
        $message = "Le document «&nbsp;$nom&nbsp;» a bien été supprimé.";
      else  {
        // Retour en arrière
        exec("mv $tmp/".escapeshellarg($nom).' '.escapeshellarg($chemin));
        $message = "Le document «&nbsp;$nom&nbsp;» n'a pas été supprimé à cause d'une erreur lors des modifications dans la base de données MySQL. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }
      exec("rm -rf $tmp");
    }
  }

  // Modification d'un document  (le répertoire choisi doit exister)
  elseif ( isset($_REQUEST['valid_modif']) && isset($chemin) && isset($repertoires[$rep = $_REQUEST['repertoire']]) )  {
    if ( !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider un document sans nom. Pour supprimer un document, il faut cliquer sur Supprimer.';
    else  {
      // Vérifications des données envoyées
      $nom_nouveau = preg_replace('#[\x00-\x1F\x7F-\x9F/\\\\]#','',basename($_REQUEST['nom']));
      $titre = $mysqli->real_escape_string($_REQUEST['titre']);
      $chemin_nouveau = "${repertoires[$rep]}/$nom_nouveau";
      $lien = ( isset($_REQUEST['lien']) ) ? 1 : 0;

      // Vérification que le document n'est pas déplacé à une place déjà prise
      if ( ( $chemin != $chemin_nouveau ) && file_exists($chemin_nouveau) )
        $message = "Le document «&nbsp;$nom&nbsp;» n'a pas été déplacé car un autre document existe à l'endroit demandé.";
      else  {
        // Pas de déplacement
        if ( $chemin == $chemin_nouveau )
          $nok = 0;
        // Déplacement du document à la destination
        else
          exec('mv '.escapeshellarg($chemin).' '.escapeshellarg($chemin_nouveau),$out,$nok);
        if ( $nok )
          $message = "Le document «&nbsp;$nom&nbsp;» n'a pas été déplacé. Résultat de la commande <code>mv</code> : $nok.";
        // Écriture MySQL
        elseif ( $mysqli->query('UPDATE documents SET nom = \''.$mysqli->real_escape_string($nom_nouveau)."', repertoire = $rep, lien = $lien, titre='$titre' WHERE id = $n")
              && $mysqli->query('ALTER TABLE documents ORDER BY repertoire,nom') )  {
          $message = "Les modifications sur le document «&nbsp;$nom&nbsp;» ont bien été prises en compte.";
          }
        else  {
          // Retour en arrière
          if ( $chemin == $chemin_nouveau )
            $message = "Les modification sur le document «&nbsp;$nom&nbsp;» n'ont pas été prises en compte. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
          else  {
            exec('mv '.escapeshellarg($chemin_nouveau).' '.escapeshellarg($chemin));
            $message = "Le document «&nbsp;$nom&nbsp;» n'a pas été déplacé à cause d'une erreur lors des modifications dans la base de données MySQL. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
          }
        }
      }
    }
  }
  
  // Envoi d'un nouveau document  (le répertoire choisi doit exister)
  elseif ( isset($_REQUEST['valid_upload']) && isset($repertoires[$rep = $_REQUEST['repertoire']]) )  {
    // Vérifications des données envoyées (on fait confiance aux utilisateurs connectés pour ne pas envoyer de scripts malsains)
//    !preg_match('/^(?:[a-z0-9_-]|\.(?!\.))+$/iD', $userfile)     preg_match('#[\x00-\x1F\x7F-\x9F/\\\\]#', $name_file)
    $nom_nouveau = $_FILES['doc']['name'];
    $titre = $mysqli->real_escape_string($_REQUEST['titre']);
    $chemin_nouveau = "${repertoires[$rep]}/$nom_nouveau";
    $lien = ( isset($_REQUEST['lien']) ) ? 1 : 0;
    if ( file_exists($chemin_nouveau) )
      $message = "Le document «&nbsp;$nom_nouveau&nbsp;» n'a pas été créé car un document de même nom existe déjà. Il faut le supprimer avant.";
    // Déplacement du document uploadé au bon endroit
    elseif ( move_uploaded_file($_FILES['doc']['tmp_name'],$chemin_nouveau) )  {
      // Taille
      $taille = intval($_FILES['doc']['size']/1024);
      $taille = ( $taille < 1024 ) ? "$taille&nbsp;ko" : intval($taille/1024).'&nbsp;Mo';
      // Écriture MySQL
      if ( $mysqli->query('INSERT INTO documents SET nom = \''.$mysqli->real_escape_string($nom_nouveau)."', repertoire = $rep, lien = $lien, titre='$titre', taille = '$taille', dateupload = DATE(NOW())")
        && $mysqli->query('ALTER TABLE documents ORDER BY repertoire,nom') )
        $message = "Le document «&nbsp;$nom_nouveau&nbsp;» a bien été mis en ligne.";
      else  {
        // Retour en arrière
        unlink($chemin_nouveau);
        $message = "Le document «&nbsp;$nom_nouveau&nbsp;» n'a pas été mis en ligne à cause d'une erreur lors des modifications dans la base de données MySQL. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }
    }
  }
  // Mise à jour des matières : celles qui offrent des docs présentent l'affichage dans le menu
  $mysqli->query('UPDATE matieres SET docs = IF(id IN (SELECT r.matiere FROM repertoires AS r LEFT JOIN documents AS d ON d.repertoire = r.id GROUP BY r.matiere),1,0)');
  $mysqli->close();
}

//////////
// HTML //
//////////
// Haut de page et menu
$p = rtrim("upload?${matiere['cle']}",'?');
$t = "Envoi et déplacement de documents - ${matiere['nom']}";
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

// Affichage du message éventuel
if ( isset($message) )
  echo "  <p class=\"annonce\">$message</p>\n\n";

// Vérification des droits sur le répertoire "documents"
if ( !is_dir('documents') )
  $erreur = 'Le répertoire «&nbsp;documents&nbsp;» n\'existe pas à la racine du site web. Il faut le créer pour pouvoir mettre des documents à l\'intérieur.';
elseif ( !is_readable('documents') || !is_executable('documents') || !is_writable('documents') )
  $erreur = 'Le répertoire «&nbsp;documents&nbsp;» n\'a pas les bons droits d\'accès. Il doit être accessible en lecture et en écriture. Il faudrait taper sur le serveur, en console&nbsp;:<br>
  <code>cd '.dirname(__FILE__).' && sudo chgrp '.`id -gn | tr -d '\n'`.' documents && sudo chmod g+w documents</code>';
// S'il n'y a pas de répertoire pour la matière, on ne pourra rien envoyer
elseif ( empty($reps_mat) )
  $erreur = 'Il n\'y a pas de répertoires pour y mettre des documents. Vous devez <a href="repertoires'.rtrim("?${matiere['cle']}",'?').'">en créer</a> avant de pouvoir envoyer des documents.';
if ( isset($erreur) )  {
  echo "  <p class=\"annonce\">$erreur</p>\n\n";
  // Bas de page
  include('bas.php');
  $mysqli->close();
  exit();
}

// Vérification de la quantité de données téléchargeable
$taille = min(ini_get('upload_max_filesize'),ini_get('post_max_size'));
if ( stristr($taille,'m') )
  $taille = substr($taille,0,-1)*1048576;
elseif ( stristr($taille,'k') )
  $taille = substr($taille,0,-1)*1024;
$message = ( $taille < 10485760 ) ? ' Cela pourrait être insuffisant si vous souhaitez envoyer des documents conséquents, mais n\'interdit pas l\'envoi de petits documents.' : '';
$taille = ( $taille < 1048576 ) ? intval($taille/1024).'&nbsp;ko' : intval($taille/1048576).'&nbsp;Mo';

// Formulaire pour upload de nouveau document suivi des remarques d'utilisation
echo <<<FIN
  <div class="item">
    <p>Vous pouvez ici envoyer des documents sur le site pour qu'ils soient téléchargeables en ligne.</p>
    <p>De façon générale, il est plus pratique pour tout le monde d'envoyer des documents de type <code>pdf</code> plutôt que des <code>doc</code> ou <code>xls</code>. Seuls les <code>pdf</code> offrent la garantie d'être lisibles de la même façon par tous et garantissent une impression conforme. La taille d'un document est limitée à $taille.$message</p>
  </div>

  <form action="" method="post" enctype="multipart/form-data" class="item admin">
    <p class="bouton_ok"><input type="submit" name="valid_upload" value="Envoyer"></p>
    <h3>Envoyer un document</h3>
    <h4><input type="file" name="doc"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Titre&nbsp;: <input type="text" name="titre" value="" size="40">
    </h4>
    <h4>Répertoire&nbsp;:
      <select name="repertoire">
$select_reps_mat      </select> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Afficher&nbsp;: <input type="checkbox" name="lien" value="1" checked>
    </h4>
    <input type="hidden" name="nmodif" value="0">
  </form>

  <div class="item">
    <p>La case «&nbsp;Afficher&nbsp;» permet d'afficher le document sur la page de téléchargements de la partie publique du site. Si elle est cochée, le document apparaît donc sur la page de téléchargement, sous la forme du «&nbsp;titre&nbsp;» donné (par exemple, on pourra mettre le titre «&nbsp;Corrigé du TD n°2&nbsp;» pour un document «&nbsp;TD2-corrigé.pdf&nbsp;»). Si ce titre est vide, le vrai nom du document apparaîtra.</p>
    <p>Tous les documents, même ceux pour lesquels la case «&nbsp;Afficher&nbsp;» est décochée, sont accessibles par l'adresse de la forme (en remplaçant les valeurs entre crochets)&nbsp;:
    <p><code>http://$site/documents/[matière]/[répertoire]/[document]</code> (pour les documents d'une matière donnée)</p>
    <p><code>http://$site/documents/[répertoire]/[document]</code> (pour les documents «&nbsp;toutes matières&nbsp;»)</p>
    <p>Le nom du document est le nom réel du document sur le serveur. On peut le modifier, ce qui déplace automatiquement le document.</p>
    <p>Pour créer un lien dans une information/un programme de colles/une entrée du cahier de texte, il suffira de copier le code qui apparaît en-dessous du document envoyé, de la forme <code>&lt;a href="[lien]"&gt;[titre]&lt;/a&gt;</code>, et de le coller dans votre texte en modifiant éventuellement le [titre].</p>
  </div>


FIN;

// Formulaire permettant l'affichage d'un répertoire particulier de la matière
// Si on a demandé un répertoire particulier
$select_reps_mat = str_replace('">','">Afficher le répertoire ',$select_reps_mat);
if ( isset($_REQUEST['rep']) )
  $select_reps_mat = str_replace("\"${_REQUEST['rep']}\"","\"${_REQUEST['rep']}\" selected",$select_reps_mat);
echo <<<FIN
  <h2>Documents déjà présents</h2>
  <form class="item" action="" method="post">
    <div>
      <select name="rep">
        <option value="0">Afficher tous les répertoires</option>
$select_reps_mat      </select>
      <input type="submit" value="Valider">
    </div>
  </form>


FIN;

// Récupération et affichage des documents
// Restriction à un seul répertoire si demandé
if ( isset($_REQUEST['rep']) && isset($reps_mat[$rep=$_REQUEST['rep']]) )
  $reps_mat = array($rep=>$reps_mat[$rep]);
foreach ( $reps_mat as $rep => $titre )  {
  $resultat = $mysqli->query("SELECT id, nom, titre, IF(lien=1,' checked','') AS lien
                              FROM documents WHERE repertoire = $rep");
  if ( $n = $resultat->num_rows )  {
    $titre .= ( $n > 1 ) ? " ($n documents)" : " ($n document)";
    echo "  <div class=\"item admin\">\n    <h3>$titre</h3>\n\n";
    while ( $r = $resultat->fetch_assoc() )  {
      // Sélection automatique du répertoire
      $select = str_replace("\"$rep\"","\"$rep\" selected",$select_reps_tout);
      // Formulaire d'un document existant
      if ( $r['id'] )  {
        $lien = htmlentities(htmlentities($repertoires[$rep].'/'.$r['nom'],ENT_NOQUOTES,'UTF-8'));
        echo <<<FIN
    <form action="" method="post" class="item admin">
      <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider"><input type="submit" name="suppr" value="Supprimer"></p>
      <h4>Nom&nbsp;: <input type="text" name="nom" value="${r['nom']}" size="30"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        Titre&nbsp;: <input type="text" name="titre" value="${r['titre']}" size="40">
      </h4>
      <h4>Répertoire&nbsp;:
        <select name="repertoire">
$select        </select> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        Afficher&nbsp;: <input type="checkbox" name="lien" value="1"${r['lien']}>
        <input type="hidden" name="nmodif" value="${r['id']}">
      </h4>
      <p>Lien&nbsp;: <code>&lt;a href="$lien"&gt;${r['titre']}&lt;/a&gt;</code></p>
    </form>


FIN;
      }
    }
    $resultat->free();
  }
  else
    echo "  <div class=\"item admin\">\n    <h3>$titre</h3>\n    <h4 class=\"warning\">Il n'y a aucun document dans ce répertoire.</h4>\n";
  echo "  </div>\n\n";
}
$mysqli->close();

// Bas de page
include('bas.php');
?>

