<?php
// Sécurité et récupération des données de configuration
// La connexion doit obligatoirement être sécurisée (OK=2).
define('OK',2);
include('debut.php');

// Récupération des matières
$mysqli = premiere_connexion();
$resultat = $mysqli->query("SELECT id, nom FROM matieres");
$mysqli->close();
$select_matieres = '';
while ( $r = $resultat->fetch_assoc() ) {
  $select_matieres .= "        <option value=\"${r['id']}\">${r['nom']}</option>\n";
  $matieres[$r['id']] = $r['nom'];
}
$resultat->free();

// Traitement d'un ajout/modification/transformation
if ( isset($_REQUEST['nmodif']) && is_numeric($n = $_REQUEST['nmodif']) )  {
  // Sauvegarde de la table contenant les données
  sauvegarde_mysql('utilisateurs');
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Pour suppression : vérification que l'utilisateur existe et n'est pas seul
  if ( isset($_REQUEST['suppr']) )  {
    $resultat = $mysqli->query("SELECT id,nom FROM utilisateurs ORDER by ABS(id-$n)");
    $r = $resultat->fetch_row();
    $nom = $r[1];
    if ( $resultat->num_rows > 1 )  {
      if ( $n == $r[0] )
        $message = ( $mysqli->query("DELETE FROM utilisateurs WHERE id = $n")
        ) ? "L'utilisateur «&nbsp;$nom&nbsp;» a bien été supprimé." : "L'utilisateur «&nbsp;$nom&nbsp;» n'a pas pu être supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }
    else
      $message = "L'utilisateur «&nbsp;$nom&nbsp;» n'a pas pu être supprimé car il est le seul utilisateur actuellement.";
    $resultat->free();
  }
  // Ajout/modification d'un utilisateur
  elseif ( isset($_REQUEST['valid_modif']) )  {
    if ( !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider un utilisateur sans nom. Pour supprimer un utilisateur, il faut cliquer sur Supprimer.';
    else  {
      // Vérifications des données envoyées
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      if ( !isset($matieres[$matiere = $_REQUEST['matiere']]) )
        $matiere = key($matieres);
      // Si n > 0 : modification d'un utilisateur existant. Si n = 0, nouvel utilisateur
      if ( $n )  {
        // Récupération du nom avant modification, pour affichage
        $resultat = $mysqli->query("SELECT nom FROM utilisateurs WHERE id = $n");
        if ( $resultat->num_rows )  {
          $r = $resultat->fetch_row();
          $nom_avant = $r[0];
          $resultat->free();
          // Vérification que le nom n'est pas celui d'un autre utilisateur
          $resultat = $mysqli->query("SELECT id FROM utilisateurs WHERE id != $n AND nom = '$nom'");
          if ( $resultat->num_rows )  {
            $message = "Les données de l'utilisateur «&nbsp;$nom_avant&nbsp;» n'ont pas pu être modifiées car un autre utilisateur porte déjà ce nom.";
            $resultat->free();
          }
          else  {
            if ( strlen($_REQUEST['ancien_mdp']) && strlen($_REQUEST['nouveau_mdp1']) && ( $_REQUEST['nouveau_mdp1'] == $_REQUEST['nouveau_mdp2'] ) )  {
              if ( $mysqli->query("UPDATE utilisateurs SET nom = '$nom', matiere = $matiere, mdp = SHA1('${_REQUEST['nouveau_mdp1']}') WHERE id = $n AND mdp = SHA1('${_REQUEST['ancien_mdp']}')") )
                $message = ( $mysqli->affected_rows ) ? "Les données de l'utilisateur «&nbsp;$nom_avant&nbsp;» ont bien été modifiées (mot de passe y compris)." : "Les données de l'utilisateur «&nbsp;$nom_avant&nbsp;» n'ont pas pu être modifiées. L'ancien mot de passe est incorrect.";
              else
                $message = "Les données de l'utilisateur «&nbsp;$nom_avant&nbsp;» n'ont pas pu être modifiées. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
            }
            else
              $message = ( $mysqli->query("UPDATE utilisateurs SET nom = '$nom', matiere = $matiere WHERE id = $n" )
              ) ? "Les données de l'utilisateur «&nbsp;$nom_avant&nbsp;» ont bien été modifiées (mais le mot de passe est resté identique)." : "Les données de l'utilisateur «&nbsp;$nom_avant&nbsp;» n'ont pas pu être modifiées. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
          }
        }
      }
      // Nouvel utilisateur
      else  {
        // Vérification que le nom n'est pas celui d'un autre utilisateur
        $resultat = $mysqli->query("SELECT id FROM utilisateurs WHERE nom = '$nom'");
        if ( $resultat->num_rows )  {
          $message = "Les données de l'utilisateur «&nbsp;$nom&nbsp;» n'ont pas pu être ajoutées car un autre utilisateur porte déjà ce nom.";
          $resultat->free();
        }
        else  {
          if ( strlen($_REQUEST['nouveau_mdp1']) && ( $_REQUEST['nouveau_mdp1'] == $_REQUEST['nouveau_mdp2'] ) )
            $message = ( $mysqli->query("INSERT INTO utilisateurs SET nom = '$nom', mdp = SHA1('${_REQUEST['nouveau_mdp1']}'), matiere = $matiere")
            ) ? "Les données de l'utilisateur «&nbsp;$nom&nbsp;» ont bien été ajoutées." : "Les données de l'utilsateur «&nbsp;$nom&nbsp;» n'ont pas pu être ajoutées. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
          else
            $message = "Les données de l'utilsateur «&nbsp;$nom&nbsp;» n'ont pas pu être ajoutées. Les mots de passe n'ont pas été correctement donnés.";
        }
      }
    }
  }
  $mysqli->close();
}

//////////
// HTML //
//////////
// Haut de page et menu
$p = 'utilisateurs';
$t = 'Modifications des utilisateurs';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

// Affichage du message éventuel
if ( isset($message) )
  echo "  <p class=\"annonce\">$message</p>\n\n";

// Description et formulaire vide pour ajout
?>
  <div class="item">
    <p>Des utilisateurs peuvent être ajoutés et modifiés sur cette page. Ces utilisateurs auront accès à cette interface. La matière qui leur est associée permettra aux liens dans le menu de les guider vers les pages (programme de colles, cahier de texte, page de téléchargement de documents, page de modification des répertoires associés) correspondant à cette matière.</p>
    <p>Les mots de passe sont chiffrés avant d'être stockés dans la base de données&nbsp;: il n'y a donc aucun souci sur leur confidentialité. Même l'administrateur du site, l'hébergeur ou d'éventuels pirates ne pourront jamais y avoir accès. Lors de la connexion, le mot de passe entré est chiffré à son tour et ce sont les deux chiffrements qui sont comparés.</p>
    <p>Attention&nbsp;: il est très dangereux que ce mot de passe soit évident. Cela peut impliquer une connexion extérieure (par exemple, d'un élève) à cette interface où presque tout est effaçable. Des sauvegardes sont réalisées, mais il vaut mieux cependant faire attention à cela en amont.</p>
  </div>

  <form action="" method="post" class="item admin">
    <h3>Ajout d'un nouvel utilisateur</h3>
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider"></p>
    <h4>Nom&nbsp;: <input type="text" name="nom" value="" size="20"></h4>
    <h4>Mot de passe&nbsp;: <input type="password" name="nouveau_mdp1" value="">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Confirmation&nbsp;: <input type="password" name="nouveau_mdp2" value="">
    </h4>
    <h4>Matière&nbsp;:
      <select name="matiere">
<?php echo $select_matieres; ?>      </select>
      <input type="hidden" name="nmodif" value="0">
    </h4>
  </form>

  <div class="item">
    <p>Le nom est le nom d'utilisateur demandé à la connexion, et utilisé uniquement à cela. Il n'est jamais affiché sur la partie publique du site, il est donc possible de mettre un prénom ou ce que l'on veut. Les accents ne posent pas de problème.</p>
    <p>Le mot de passe est à entrer deux fois pour éviter les erreurs de saisie. Un bon mot de passe est un mot de passe d'au moins 8 caractères contenant des lettres, des chiffres et au moins un symbole parmi «&nbsp;?&nbsp;;&nbsp;:&nbsp;!&nbsp;.&nbsp;,-&nbsp;_&nbsp;».</p>
    <p>La matière sert à spécifier des liens rapides vers les pages concernées dans le menu pour cet utilisateur, et est utilisée uniquement à cela. Elle n'a aucune incidence sur le remplissage des pages d'informations et n'empêche pas de modifier les programmes de colles/cahiers de texte/documents d'une autre matière.</p>
  </div>
  
<?php

// Récupération et affichage des pages
$resultat = $mysqli->query('SELECT id, nom, matiere FROM utilisateurs');
$mysqli->close();
if ( $resultat->num_rows )  {
?>
  <h2>Utilisateurs existants</h2>

  <div class="item">
    <p>Il est possible de modifier le nom ou le mot de passe des utilisateurs existants. Pour le mot de passe, il faut préciser le mot de passe actuel et taper deux fois le nouveau pour éviter les erreurs de saisie.</p>
    <p>Il est aussi possible de modifier la matière associée à chaque utilisateur. Cette modification prendra effet à la prochaine connexion de l'utilisateur concerné&nbsp;: si vous souhaitez changer votre matière associée, vous devrez vous déconnecter et vous connecter à nouveau pour que cela soit pris en compte.</p>
  </div>
  
<?php
  while ( $r = $resultat->fetch_assoc() )  {
  $select = str_replace("\"${r['matiere']}\"","\"${r['matiere']}\" selected",$select_matieres);
  echo <<<FIN
  <form action="" method="post" class="item admin">
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider"><input type="submit" name="suppr" value="Supprimer"></p>
    <h4>Nom&nbsp;: <input type="text" name="nom" value="${r['nom']}" size="20"></h4>
    <h4>Changer de mot de passe&nbsp;:</h4>
      <p>Mot de passe actuel&nbsp;: <input type="password" name="ancien_mdp" value=""></p>
      <p>Nouveau mot de passe&nbsp;: <input type="password" name="nouveau_mdp1" value="">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        Confirmation&nbsp;: <input type="password" name="nouveau_mdp2" value="">
      </p>
    <h4>Matière&nbsp;:
      <select name="matiere">
$select      </select>
      <input type="hidden" name="nmodif" value="${r['id']}">
    </h4>
  </form>


FIN;
  }
  $resultat->free();
}

// Bas de page
include('bas.php');
?>

